// Generated by CoffeeScript 1.9.3
(function() {
  var baseUrl, checkAndRedirect, getLanguageLinks, hideOverlay, ready, referrerHasSameHost, removeEl;

  baseUrl = function(href) {
    var baseurl, p;
    p = href.indexOf('//');
    p = href.indexOf('/', p + 2);
    return baseurl = href.substr(0, p + 1);
  };

  ready = function(fn) {
    if (document.readyState !== 'loading') {
      fn();
    } else {
      document.addEventListener('DOMContentLoaded', fn);
    }
  };

  referrerHasSameHost = function() {
    var base;
    if (document.referrer) {
      base = baseUrl(document.referrer);
      return window.location.href.substr(0, base.length) === base;
    }
    return false;
  };

  getLanguageLinks = function() {
    var e, i, len, links, ref;
    links = {};
    ref = document.querySelectorAll('link[rel="alternate"][hreflang]');
    for (i = 0, len = ref.length; i < len; i++) {
      e = ref[i];
      links[e.getAttribute('hreflang')] = e.getAttribute('href');
    }
    return links;
  };

  hideOverlay = function() {
    ready(function() {
      removeEl(document.getElementById('geoip-language-redirect-overlay'));
      if (window.geoip_language_redirect_overlay_old_error) {
        window.onerror = window.geoip_language_redirect_overlay_old_error;
      }
    });
  };

  removeEl = function(el) {
    el && el.parentNode && el.parentNode.removeChild(el);
    el = null;
  };

  checkAndRedirect = function() {
    var current, links;
    if (referrerHasSameHost()) {
      hideOverlay();
      return;
    }
    links = getLanguageLinks();
    current = document.getElementsByTagName('html')[0].getAttribute('lang');
    jQuery.getJSON('/geoip-language-suggestions').done(function(data) {
      var i, lang, len;
      for (i = 0, len = data.length; i < len; i++) {
        lang = data[i];
        if (lang === current) {
          hideOverlay();
          return;
        }
        if (links.hasOwnProperty(lang)) {
          window.location = links[lang];
          return;
        }
      }
      hideOverlay();
    }).fail(function() {
      hideOverlay();
    });
  };

  checkAndRedirect();

}).call(this);
